#include <default.c>
#include <windows.h>

// call types
#define HGET		100
#define HPOST		200
#define HDELETE	300

//operations
#define ACCOUNTS					01
#define ACCOUNTS_BALANCES			02
#define ACCOUNTS_ID					03
#define ACCOUNTS_ID_BALANCES		04
#define ACCOUNTS_ID_HISTORY			05
#define ACCOUNTS_ID_HOLDINGS		06
#define ACCOUNTS_ID_ORDERS			11
#define ACCOUNTS_ID_ORDERS_PREVIEW	12
#define MARKET_CLOCK				21
#define MARKET_EXT_QUOTES			22
#define MARKET_NEWS_SEARCH			23
#define MARKET_NEWS_ID				24
#define MARKET_OPTIONS_SEARCH		25
#define MARKET_OPTIONS_STRIKES		26
#define MARKET_OPTIONS_EXPIRATIONS	27
#define	MARKET_TIMESALES			28
#define MARKET_TOPLISTS				29
#define	MEMBER_PROFILE				31
#define UTILITY_STATUS				41
#define UTILITY_VERSION				42
#define WATCHLISTS					51
#define WATCHLISTS_ID				52
#define WATCHLISTS_ID_SYMBOLS		53
#define WATCHLISTS_ID_SYMBOLS_SYM	54

//return formats & oauth
#define	JSON	1000
#define XML		2000



void nl(){printf("\n");return;}

bool __cdecl CGetURL(char* output, int n, int calltype, int operation, int responseMode, char* args);
bool __cdecl CGetResponse(char* output, int n, int calltype, int operation, int responseMode, char* args, char* data);
bool __cdecl CSaveResponse(char* filename, int calltype, int operation, int responseMode, char* args, char* data);
void __cdecl CTestParseHoldings();

void initialize()
{
	static bool initialized = false;
	if(initialized) return;
	
	CTestParseHoldings = DefineApi("AllyInvest!CTestParseHoldings");
	CGetURL = DefineApi("AllyInvest!CGetURL");
	CGetResponse = DefineApi("AllyInvest!CGetResponse");
	CSaveResponse = DefineApi("AllyInvest!CSaveResponse");
	
	initialized = true;
	return;
	
}

void dostuff()
{
	if(!CSaveResponse("./AllyQuotes1.xml", HGET, MARKET_TIMESALES, XML, "symbols=AAPL&interval=1min&startdate=2017-01-01&enddate=2017-02-01",""))
	printf("\nAn error occured.");
	else printf("\nXML file saved!");
	
	if(!CSaveResponse("./AllyQuotes2.xml", HGET, MARKET_TIMESALES, XML, "symbols=AAPL&interval=1min&startdate=2017-01-01&enddate=2017-03-01",""))
	printf("\nAn error occured.");
	else printf("\nXML file saved!");
	
	if(!CSaveResponse("./AllyQuotes3.xml", HGET, MARKET_TIMESALES, XML, "symbols=AAPL&interval=1min&startdate=2017-01-01&enddate=2017-04-01",""))
	printf("\nAn error occured.");
	else printf("\nXML file saved!");
	
	if(!CSaveResponse("./AllyQuotes1.json", HGET, MARKET_TIMESALES, JSON, "symbols=AAPL&interval=1min&startdate=2017-01-01&enddate=2017-02-01",""))
	printf("\nAn error occured.");
	else printf("\nJSON file saved!");
	
	if(!CSaveResponse("./AllyQuotes2.json", HGET, MARKET_TIMESALES, JSON, "symbols=AAPL&interval=1min&startdate=2017-01-01&enddate=2017-03-01",""))
	printf("\nAn error occured.");
	else printf("\nJSON file saved!");
	
	if(!CSaveResponse("./AllyQuotes3.json", HGET, MARKET_TIMESALES, JSON, "symbols=AAPL&interval=1min&startdate=2017-01-01&enddate=2017-04-01",""))
	printf("\nAn error occured.");
	else printf("\nJSON file saved!");

	return;
}


int main()
{
	initialize();
	dostuff();

	return 0;
}